/*
 * Copyright (c) 2004 Iwata <iwata@quasiquote.org>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include <gauche/extend.h>
#include <ffi.h>

typedef struct ScmLazyRec {
	SCM_HEADER;
	ScmObj name;
	void *handle;
} ScmLazy;

SCM_CLASS_DECL(Scm_LazyClass);

#define SCM_CLASS_LAZY      (&Scm_LazyClass)
#define SCM_LAZY_FFI(obj)   ((ScmLazy*)obj)
#define SCM_LAZY_FFI_P(obj) SCM_XTYPEP(obj, SCM_CLASS_LAZY)

#define LAZY_VOID_TYPE       0
#define LAZY_INT_TYPE        1
#define LAZY_DOUBLE_TYPE     2
#define LAZY_PTR_TYPE        3
#define LAZY_CHAR_TYPE       4
#define LAZY_SCHEME_TYPE     5
#define LAZY_SCHEME_PTR_TYPE 6
#define LAZY_STRING_TYPE     7

extern char lazy_ffi_strerr[1024];

extern ScmObj Scm_LazyStrerr();
extern ScmObj Scm_LazyOpen(ScmString *);
extern ScmObj Scm_LazyClose(ScmLazy *);
extern ScmObj Scm_LazyCall(ScmLazy *, int, ScmString *, ScmObj, ScmObj);
extern void finalize_lazy(GC_PTR, GC_PTR);
